import math

from axipy import CoordSystem, Point, Pnt, ProgressSpecification, ProgressGuiFlags, AxipyProgressHandler
from axipy import LinearUnits
from PiketPoints.ui.addTools.helperUnit import Distance


def linePikets(start_pnt:Pnt,end_pnt:Pnt,step:float,offset:float,cs:CoordSystem=None):
    base_pnt=start_pnt
    ''' Расстояние и угол между двумя точками '''
    dist, azimuth = Point.distance_by_points(start_pnt, end_pnt, cs)

    #if dist_next_piket<step:
    #    return None,
    if offset>0.0:
        pass

class PointsPiket:

    def __init__(self,ph: AxipyProgressHandler=None,add_property:dict=None):
        self.__progress=ph
        self.__cancel = False
        self.__add_piket_in_source = False
        self.__add_node_in_piket = False
        if add_property is not None:
            try:
                self.__add_piket_in_source = add_property['add_piket_in_source']
            except:
                pass
            try:
                self.__add_node_in_piket = add_property['add_node_in_piket']
            except:
                pass
    @property
    def isCancel(self):
        return self.__cancel
    def buildPikets(self,points: list,step:Distance, cs: CoordSystem = None):
        self.__cancel=False
        self.__cs=cs
        self.__step_dist=step
        self.__step=step.to_unit(LinearUnits.m)
        self.__common_dist=0.0
        self.__curent_offset=0.0
        out_pikets_points = []
        count_point = len(points)
        #out_pikets_points.append(points[0])
        out_pikets_points.append({'xy': points[0], "dist":0,"type":"node"})
        for i in range(count_point - 1):
            start_pnt = points[i]
            next_point = points[i + 1]
            piket_points=self.linePikets(start_pnt,next_point)
            if piket_points is None:
                if i>0:
                    out_pikets_points.append({'xy': start_pnt, "dist":0,"type":"node"})
                out_pikets_points.append({'xy': next_point, "dist": 0, "type": "node"})
            if piket_points is not None:
                temp_piket_dist=[]
                for j,pnt in enumerate(piket_points):
                    temp_piket_dist.append({'xy':pnt,"dist":0,"type":"piket"})
                if self.__add_node_in_piket :
                    ''' Добавляем узлы в пикеты'''
                    if (not comparePnt(start_pnt,piket_points[0],self.__cs)) and i>0:
                        ''' первая точка сегмента не совпадает с первым пикетом '''
                        previous_piket = out_pikets_points[-1]
                        if not comparePnt(previous_piket['xy'], start_pnt, self.__cs):
                            temp_piket_dist.insert(0,{'xy':start_pnt,"dist":99999,"type":"node"})
                    if  not comparePnt(next_point,piket_points[-1],self.__cs):
                        ''' последняя точка сегмента не совпадает с последним пикетом '''
                        previous_piket=out_pikets_points[-1]
                        if not comparePnt(previous_piket['xy'],next_point,self.__cs):
                            temp_piket_dist.append( {'xy': next_point, "dist": -99999,"type":"node"})
                out_pikets_points.extend(temp_piket_dist)
                #dist, azimuth = Point.distance_by_points(out_pikets_points[-1]['xy'], next_point, self.__cs)
                dist, azimuth = Point.distance_by_points(piket_points[-1], next_point, self.__cs)
                self.__curent_offset = dist
        if len(out_pikets_points)==1:
            return None
        if self.__add_node_in_piket:
            ''' Проверяем последний узел попал в список узлов '''
            last_point=out_pikets_points[-1]
            last_node=points[len(points)-1]
            if not comparePnt(last_point['xy'],last_node,self.__cs):
                out_pikets_points.append( {'xy': last_node, "dist": -99999,"type":"node"})
        id_piket=0
        for i,piket in enumerate(out_pikets_points):
            if i==0:
                id_piket = id_piket + 1
                continue
            if piket["type"]=='piket':
                piket['dist']=id_piket*self.__step_dist.value
                id_piket=id_piket+1
                continue
            pre_dist=out_pikets_points[i-1]['dist']
            dist_pikets,azimuth=Point.distance_by_points(out_pikets_points[i-1]['xy'], out_pikets_points[i]['xy'], self.__cs)
            out_pikets_points[i]['dist']=pre_dist+dist_pikets
        return out_pikets_points
    def linePikets(self,start_pnt: Pnt, end_pnt: Pnt):
        piket_points=[]
        ''' Расстояние и угол между двумя точками '''
        dist, azimuth = Point.distance_by_points(start_pnt, end_pnt, self.__cs)
        dist_next_piket=self.__common_dist+self.__step
        if (self.__common_dist+dist)<dist_next_piket:
            if self.__curent_offset>0.0 and ((self.__curent_offset+dist)>self.__step):
                ''' Пикет на сегменте '''
                distance_next_piket=self.__step-self.__curent_offset
                pnt_next = Point.point_by_azimuth(start_pnt, azimuth, distance_next_piket, self.__cs)
                piket_points.append(pnt_next)
                return piket_points
            if self.__curent_offset<=0.0:
                self.__curent_offset=dist
            else:
                self.__curent_offset =self.__curent_offset+ dist
            return None
        pnt_start=start_pnt
        if self.__curent_offset>0.0:
            dist_next_piket=self.__step-self.__curent_offset
            pnt_start=Point.point_by_azimuth(start_pnt,azimuth,dist_next_piket,self.__cs)
            piket_points.append(pnt_start)
            self.__common_dist=self.__common_dist+self.__step
            self.__curent_offset=0.0
            dist_new=dist-dist_next_piket
            if dist_new<=self.__step:
                if dist_new<self.__step:
                    self.__curent_offset=self.__step-dist_new
                    return piket_points
                if dist_new==self.__step:
                    piket_points.append(end_pnt)
                    self.__common_dist=self.__common_dist + self.__step
                    self.__curent_offset =0
                    return piket_points
            dist=dist_new
        #count_piket_in_segment=int(math.trunc(dist/self.__step))
        count_piket_in_segment = int(dist / self.__step+0.1)
        curent_piket=pnt_start
        for i in range(count_piket_in_segment):
            if self.__progress is not None:
                if self.__progress.is_canceled():
                    self.__cancel=True
                    return None
                self.__progress.add_progress(1)
            curent_piket=Point.point_by_azimuth(curent_piket,azimuth,self.__step,self.__cs)
            dist_temp, azimuth = Point.distance_by_points(curent_piket, end_pnt, self.__cs)
            piket_points.append(curent_piket)
            self.__common_dist=self.__common_dist+self.__step
        delta=dist_temp-self.__step
        return piket_points
def comparePnt(pnt1,pnt2,cs):
    p1=Point(pnt1.x,pnt1.y,cs)
    p2=Point(pnt2.x,pnt2.y,cs)
    return p1.equals(p2)




